



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>SpringCloud的EurekaClient ： 客户端应用访问注册的微服务（有断路器场景）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">SpringCloud的EurekaClient ： 客户端应用访问注册的微服务（有断路器场景）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 00:14:52 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>演示客户端应用如何访问注册在EurekaServer里的微服务</p>
<h1>一、概念和定义</h1>
<p>采用Ribbon或Feign方式访问注册到EurekaServer中的微服务。<br>1、Ribbon实现了客户端负载均衡，<br>2、Feign底层调用Ribbon<br>3、注册在EurekaServer中的微服务api，不通过ip访问，而是通过ServiceId访问<br>   其中ServiceId即配置项spring.application.name标识的注册到EurekaServer中的名称。<br>   使用Feign/Ribbon客户端访问微服务的api，如：<br>     http://ServiceHelloA/HelloA?name=tom<br>     http://ServiceHelloB/HelloB?name=Jerry<br>   说明客户端负载均衡Ribbon解释了ServiceHelloA映射的ip+端口.</p>
<h1>二、开发案例</h1>
<h2>1、Ribbon服务代码</h2>
<h3>1.1、之前</h3>
<p>@Service<br>public class HelloARibbonService {</p>
<p>@Autowired<br>	    RestTemplate restTemplate;</p>
<p>public String visitHelloA(String name) {<br>	        return restTemplate.getForObject("http://SERVICEHELLOA/HelloA?name="+name,String.class);<br>	    }</p>
<p>}</p>
<h3>1.2、现在</h3>
<p>@Service<br>public class HelloARibbonService {</p>
<p>@Autowired<br>	    RestTemplate restTemplate;</p>
<p>@HystrixCommand(fallbackMethod = "visitHelloAError")<br>	    public String visitHelloA(String name) {<br>	        return restTemplate.getForObject("http://SERVICEHELLOA/HelloA?name="+name,String.class);<br>	    }</p>
<p>public String visitHelloAError(String name) {<br>	        return "HystrixRibbon::hi,"+name+",sorry,visitHelloAError!";<br>	    }<br>	    <br>	}</p>
<h2>2、Feign 服务代码</h2>
<h3>2.1、之前</h3>
<p>@FeignClient(value = "SERVICEHELLOA")<br>public interface HelloAFeignService {</p>
<p>@RequestMapping(value = "/HelloA",method = RequestMethod.GET)<br>    String visitHelloA(@RequestParam(value = "name") String name);</p>
<p>}</p>
<h3>2.2、现在</h3>
<p><em>/**<br> * FeignClient默認引入Hystrix支持，可以關閉<br> * 使用非常簡單，聲明fallback，並且定時失敗響應即可 <br> */<br>@FeignClient(value = "SERVICEHELLOA",fallback = HelloAFeignErrorService.class)<br>public interface HelloAFeignService {</em></p>
<p>@RequestMapping(value = "/HelloA",method = RequestMethod.GET)<br>    String visitHelloA(@RequestParam(value = "name") String name);</p>
<p>}<br>package org.wanma.example.springcloud.clientfeign.service;</p>
<p>import org.springframework.stereotype.Component;</p>
<p>@Component<br>public class HelloAFeignErrorService implements HelloAFeignService {<br>	<br>    @Override<br>    public String visitHelloA(String name) {<br>    	return "HystrixFeign::hi,"+name+",feign visitHelloA error!";<br>    }<br>    <br>}</p>
<h1>三、案例说明</h1>
<p>1、访问注册中心，发现EurekaServer启动了，Ribbon/Feign客户端启动了，但是服务（ServiceHelloA和ServiceHelloB）一个也没有启动</p>
<p>http://localhost:8101/</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1099841/201705/1099841-20170512112327129-1551839578.png"></p>
<p>2、通过Ribbon访问HelloA</p>
<p><a href="http://localhost:8301/HelloARibbon?name=lexiaofei" rel="external nofollow noreferrer">http://localhost:8301/HelloARibbon?name=lexiaofei</a><br> <img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1099841/201705/1099841-20170512112118301-245978647.png"></p>
<p>3、通过Feign访问HelloA</p>
<p><a href="http://localhost:8321/HelloAFeign?name=liangshengqi" rel="external nofollow noreferrer">http://localhost:8321/HelloAFeign?name=liangshengqi</a></p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1099841/201705/1099841-20170512112144238-1804180166.png"></p>
<p>四、代码下载</p>
<p><a href="https://github.com/lexiaofei/workspace_SpringHystrix.git" rel="external nofollow noreferrer">https://github.com/lexiaofei/workspace_SpringHystrix.git</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/4qny6j8r.html">三大框架SSH整合</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqd54x79.html">浏览器-03 WebKit 渲染1</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxvovv9.html">远哥教你MuleESB系列视频教程</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvg41zq.html">Java多线程 wait&comma; notify 和 notifyAll</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1mr7x8.html">The property &amp;&num;39&semi;RowId&amp;&num;39&semi; is part of the object&amp;&num;39&semi;s key information and cannot be modified&period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1korm9.html">hdoj 1596 find the safest road【最短路变形，求最大安全系数】</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xm2dr9.html">SCOI2014省选总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/93ypx208.html">&lbrack;ios2&rsqb;iphone编程中使用封装的NSLog来打印调试信息 【转】</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j24lw8.html">常见浏览器的宽高代码写法！有原生JavaScript和jquery两种写法-------------------------------以及我的个人网站</a>
		</li>
						<li><a href="https://www.batexi.com/a/9geyy678.html">如何向android studio中导入第三方类库</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp31y69.html">C&num; 默认访问修饰符</a>
		</li>
						<li><a href="https://www.batexi.com/a/960714y9.html">&lbrack;Jenkins&rsqb;CentOS7下Jenkins搭建</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gdp5zq.html">swiper嵌套小demo&lpar;移动端触摸滑动插件&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/95g7j1mq.html">SpriteKit  关于categoryBitMask   collisionBitMask   contactTestBitMask 遇到的一些问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jrlg0q.html">js中用变量作为&dollar;&lpar;&rpar;内id的值、动态获取id，及获取其下面的class元素</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2kxd6vq.html">swagger的说明、配置及使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7edkrj9.html">【转】Spark源码分析之-scheduler模块</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rnw4p4q.html">maven管理工具</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwly1ok9.html">vue&period;js利用vue&period;router创建前端路由</a>
		</li>
						<li><a href="https://www.batexi.com/a/8odjkypq.html">firebug&comma;chrome调试工具的使用</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/96pk1xj8.html">Facebook兆级别图片存储及每秒百万级别图片查询原理</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlj2zpe9.html">基于netcore实现mongodb和ElasticSearch之间的数据实时同步的工具（Mongo2Es）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdp1e5xq.html">Eclipse 基础操作与设置</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7zvm0e9.html">Java IO流简介</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ey6ydz9.html">【数据库】mysql数据库索引</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnj6vyk8.html">【Linux】 文本比较工具 diff和cmp</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jekyl8.html">&lpar;Matlab&rpar;GPU计算及CPU计算能力的比较</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4z54509.html">class 选择器</a>
			</li>
						<li><a href="https://www.batexi.com/a/950lj068.html">游戏安全有多重要？&mdash;&mdash;GAME-TECH游戏开发者技术沙龙</a>
			</li>
						<li><a href="https://www.batexi.com/a/93yrnwr8.html">hadoop集群简单搭建</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
